const { _, log } = require('./basd')

class Fig {
  #result
  constructor(opts = {}) {
    this.#result = {}
    this.parse(opts)
  }
  static parse(opts) {
    return Reflect.construct(Fig, [opts]).result
  }
  get result() {
    return this.#result
  }
  parse(opts) {
    const stack = this.#getStack(opts)
    while (stack.length) {
      const next = stack.pop()
      const ext = _.cloneDeep(_.get(opts, next))
      let ref
      if (_.isObj(ext) && ext.extends) {
        ref = _.cloneDeep(_.get(opts, ext.extends))
        delete ext.extends
        ref = _.cloneDeep(_.assign({}, ref, ext))
      } else if (_.isArr(ext)) {
        log('is array', ext)
      } else if (_.isStr(ext)) {
        ref = _.cloneDeep(_.get(opts, ext))
      }
      if (_.isStr(ref) && _.get(opts, ref))
        stack.unshift(next)
      else
        _.set(opts, next, ref)
    }
    for (const key in _.omit(opts, ['conf']))
      this.#result[key] = _.cloneDeep(opts[key])
    _.objSort(this.#result)
  }
  #getParent(parent, key) {
    let arr = _.toArr(parent)
    arr.push(key)
    return arr.join('.')
  }
  #getStack(orig, opts, stack = [], parent) {
    opts = opts || orig
    for (const key in opts) {
      const val = opts[key]
      if (_.isStr(val)) {
        const res = _.get(orig, val)
        if (!_.isNil(res))
          if (key === 'extends')
            stack.push(parent)
          else
            stack.push(this.#getParent(parent, key))
      } else if (_.isObj(val))
        this.#getStack(orig, val, stack, this.#getParent(parent, key))
      else if (_.isArr(val)) {
        for (let ii = 0; ii < val.length; ii++) {
          let _val = val[ii]
          this.#getStack(orig, _val, stack, this.#getParent(parent, [key, ii].join('.')))
        }
      }
    }
    return stack
  }
}

module.exports = Fig
