// DEPRECATE?

const { _, log } = require('./basd')
const Heap = require('./heap')

class LockV1 extends Heap {
  static putondb() {
    if (opts.lock) {
      if (!this.__root.__queue)
        _.objProp(this.__root, '__queue', new Lock)
      Lock.do(this, ['get', 'put', 'del', 'batch'], this.__root.__queue)
    }
  }
  constructor(opts = {}) {
    super(opts)
    this.locked = false
  }
  next() {
    let next = this.peek()
    if (this.locked || !next)
      return
    this.locked = true
    next = this.remove()
    const { fn, resolve } = next
    return _.respond(fn()).then(res => {
      this.locked = false
      this.next()
      resolve(res)
    })
  }
  add(fn, priority = 1) {
    return new Promise(resolve => {
      this.insert({ fn, resolve }, priority)
      this.next()
    })
  }
  end() {
    return new Promise(resolve => _.respond(this.add(resolve)))
  }
  static do(obj, props, heap, opts) {
    heap = heap || new this(opts)
    if (!_.isObj(obj) || !heap || !(heap instanceof Heap) || !_.isArray(props))
      throw new Error('invalid parameters')
    for (const key of props) {
      const fn = _.isFn(obj[key]) ? obj[key] : false
      if (!fn)
        throw new Error('Lock requires existing methods')
      _.objProp(obj, key, (...args) => {
        return heap.add(() => _.respond(fn.apply(obj, args)))
      }, { enumerable: false, writable: true, configurable: true })
    }
    return heap
  }
}

function Lock(db, key, mode) {
  if (!db.__locks)
    _.objProp(db, '__locks', {})
  if (!db.__locks.read) db.__locks.read = {}
  if (!db.__locks.write) db.__locks.write = {}
  // let sym = Object.getOwnPropertySymbols(db.__db).find(s => String(s) === 'Symbol(options)')
  // let sym = Object.getOwnPropertySymbols(db.__db).find(s => String(s) === 'Symbol(keyEncoding)')
  // let opts = db.__db[sym]
  const ekey = db.__db.options
    && typeof db.__db.options.keyEncoding === 'object'
    && db.__db.options.keyEncoding.encode
      ? db.__db.options.keyEncoding.encode(key)
      : key
  if (!mode) mode = 'w'
  if (typeof mode === 'object')
    mode = [(mode.read ? 'r' : ''), (mode.write ? 'w' : '')].join('')
  mode = String(mode).split('').sort().join('')
  if (/[^rw]/.test(mode))
    throw new Error('unknown mode: ' + mode)
  if (/r/.test(mode) && db.__locks.read[ekey]) return null
  if (/w/.test(mode) && db.__locks.write[ekey]) return null
  if (/r/.test(mode)) db.__locks.read[ekey] = true
  if (/w/.test(mode)) db.__locks.write[ekey] = true
  return function (res) {
    if (/r/.test(mode))
      delete db.__locks.read[ekey]
    if (/w/.test(mode))
      delete db.__locks.write[ekey]
    return res
  }
}

module.exports = Lock


function LevelLock(db, key, mode) {
  if (!db._locks) db._locks = {}
  if (!db._locks.read) db._locks.read = {}
  if (!db._locks.write) db._locks.write = {}
  const ekey = db.options
    && typeof db.options.keyEncoding === 'object'
    && db.options.keyEncoding.encode
      ? db.options.keyEncoding.encode(key)
      : key
  if (!mode) mode = 'w'
  if (typeof mode === 'object') {
    mode = [
      (mode.read ? 'r' : ''),
      (mode.write ? 'w' : '')
    ].join('')
  }
  mode = String(mode).split('').sort().join('')
  if (/[^rw]/.test(mode)) {
    throw new Error('unknown mode: ' + mode)
  }
  if (/r/.test(mode) && db._locks.read[ekey]) return null
  if (/w/.test(mode) && db._locks.write[ekey]) return null
  if (/r/.test(mode)) db._locks.read[ekey] = true
  if (/w/.test(mode)) db._locks.write[ekey] = true
  return function () {
    if (/r/.test(mode)) {
      delete db._locks.read[ekey]
    }
    if (/w/.test(mode)) {
      delete db._locks.write[ekey]
    }
  }
}

class LockTmp extends Heap {
  constructor(opts = {}) {
    super(opts)
    this.locked = false
  }
  next() {
    let next = this.peek()
    if (this.locked || !next)
      return
    this.locked = true
    next = this.remove()
    const { fn, resolve } = next
    return _.respond(fn()).then(res => {
      this.locked = false
      this.next()
      resolve(res)
    })
  }
  add(fn, priority = 1) {
    return new Promise(resolve => {
      this.insert({ fn, resolve }, priority)
      this.next()
    })
  }
  end() {
    return new Promise(resolve => _.respond(this.add(resolve)))
  }
  static do(obj, props, heap, opts) {
    heap = heap || new this(opts)
    if (!_.isObj(obj) || !heap || !(heap instanceof Heap) || !_.isArray(props))
      throw new Error('invalid parameters')
    for (const key of props) {
      const fn = _.isFn(obj[key]) ? obj[key] : false
      if (!fn)
        throw new Error('Lock requires existing methods')
      _.objProp(obj, key, (...args) => {
        return heap.add(() => _.respond(fn.apply(obj, args)))
      }, { enumerable: false, writable: true, configurable: true })
    }
    return heap
  }
}

// module.exports = Lock
