class PromiseQueue {
  constructor() {
    this.queue = Promise.resolve()
    this.errorHandler = (err) => console.error(err)
    this.size = 0
  }
  setErrorHandler(fn) {
    this.errorHandler = fn
  }
  insert(fn) {
    this.size++
    this.queue = this.queue.then(() => new Promise((resolve, reject) => {
      fn(err => {
        if (err) return reject(err)
        this.size--
        resolve()
      })
    })).catch(this.errorHandler)
    return this.queue
  }
  clear() {
    this.queue = Promise.resolve()
    this.size = 0
  }
}

module.exports = PromiseQueue
