const { _, log } = require('./basd')

class Start {
  constructor(opts = {}) {
    this.constructor.primary(opts)
      .then(client => {
        _.objProp(this, 'client', client)
        return this.start()
      })
      .then(() => {
        if (this._onStarted)
          return this._onReady().then(() => this._onStarted())
        return this._onReady()
      })
    this.start()
  }
  static get primary() {
    return async function Mock() { return {}}
  }
  static start(opts) {
    const obj = new this(opts)
    return obj.start().then(() => obj)
  }
  start() {
    return new Promise((resolve, reject) => {
      if (this.client)
        return resolve()
      else if (!this._onStarted) {
        Object.defineProperty(this, '_onStarted', { configurable: true, value: () => {
          delete this._onStarted
          resolve()
        }})
      } else {
        const orig = this._onStarted
        Object.defineProperty(this, '_onStarted', { configurable: true, value: () => {
          orig()
          resolve()
        }})
      }
    })
  }
  async _onReady() {
  }
}

module.exports = Start
