const { _, log } = require('./basd')

class Tree {
  static construct(node, opts = {}) {
    _.objProp(node, '_slug', opts._slug)
    _.objProp(node, '_parent', opts._parent)
    _.objProp(node, '_root', opts._parent ? (opts._parent._root || opts._parent) : null)
    const path = []
    if (node._parent) {
      if (!node._parent._path.length) {
        path.push(node._slug)
      } else {
        path.push(node._parent._slug)
        path.push(node._slug)
      }
    }
    _.objProp(node, '_path', path)
  }
  static test(node, slug) {
    if (node[slug] instanceof node.constructor)
      return true
    else if (node.hasOwnProperty(slug))
      throw new Error(`"${slug}" is a reserved word`)
  }
  static sub(node, slug, opts, args, Class) {
    opts = _.merge(opts, { _parent: node, _slug: slug })
    const sub = Reflect.construct(Class || node.constructor, [opts, ..._.toArr(args)])
    _.objProp(node, slug, sub, { enumerable: true, configurable: true })
    return sub
  }
}

module.exports = Tree


/*
const { _, log } = require('basd')
const Crypto = require('basd/crypto')
const { HASH_LENGTH } = require('basd/util')

const VertexMixin = (Class = class {}) => 
class Vertex extends Class {
  constructor(name = '_root_', opts) {
    super(...arguments)
    opts = _.defaults(opts, { link: null })
    _.objProp(this, '__name', name, { enumerable: true, writable: true, configurable: true })
    _.objProp(this, '__hash', null, { enumerable: true, writable: true, configurable: true })
    _.objProp(this, '__link', opts.link, { enumerable: false, writable: true })
    _.objProp(this, '__root', this, { enumerable: false, writable: true })
    _.objProp(this, '__kids', {}, { enumerable: true })
    _.objProp(this, '__hashLength', HASH_LENGTH)
    _.objProp(this, '__opts', _.omit(opts, ['link']))
    _.objProp(this, '__Vertex', this.constructor)
    if (opts.link) {
      let parent = this.__link
      while (parent) {
        if (!parent.__link)
          this.__root = parent
        parent = parent.__link
      }
    }
    this.__hash = this.getHash(this)
    return Vertex.returnProxy(this)
  }
  static returnProxy(self) {
    return new Proxy(self, {
      get: (obj, key) => {
        if (_.isNil(obj[key])) {
          if (obj.__kids[key])
            return obj.__kids[key]
          // if (_.isFn(self.__proxy)) {
          //   const res = self.__proxy(obj, key)
          //   if (!_.isNil(res))
          //     return res
          // }
        }
        return obj[key]
      }
    })
  }
  getHashObj({ __name: name, __link: link, __kids: kids }) {
    link = link && link.__name
    kids = _.transform(kids, (acc, cur) => acc.push(cur.__hash), [])
    return { name, link, kids }
  }
  getHash(input) {
    const obj = this.getHashObj(input)
    return Crypto.hash(obj, this.__hashLength)
  }
  add(name, opts) {
    opts = _.assign(this.__opts, _.defaults(opts, { link: this }))
    if (!this.hasKid(name))
      return false
    if (this.__kids[name])
      return this.__kids[name]
    const node = new this.__Vertex(name, opts)
    node.__hash = node.getHash(node)
    this.__kids[name] = node
    this.__hash = this.getHash(this)
    return node
  }
  getPath(slug) {
    let node = this
    const path = [node.__name]
    if (!_.isNil(slug))
      path.push(slug)
    while (node.__link) {
      node = node.__link
      path.unshift(node.__name)
    }
    return path
  }
  hasKid(name) {
    return true
    // return this.__state.kids.includes(name)
  }
  walkPath(fn, reverse = false) {
    let node = this.__root
    const path = this.getPath()
    if (reverse) {
      path.shift()
      while (path.length) {
        fn(_.get(node, path))
        path.pop()
      }
      fn(node)
    } else {
      path.shift()
      fn(node)
      for (const key of path)
        fn(node = node[key])
    }
  }
}

module.exports = new Proxy(class {
  static get mixin() { return VertexMixin }
  }, {
  construct: (Class, args, target) => _.nameExtend(target.name, VertexMixin(), ...args),
  apply: (Class, target, args) => Reflect.construct(VertexMixin(), args)
})

*/
