# Contributing to Base

We love your input! We want to make contributing to this project as easy and transparent as possible, whether it's:

- Reporting a bug
- Discussing the current state of the code
- Submitting a fix
- Proposing new features

## We Develop with GitLab

We use GitLab to host code, to track issues and feature requests, as well as accept merge requests.

## We Use [GitLab Flow](https://docs.gitlab.com/ee/topics/gitlab_flow.html#introduction-to-gitlab-flow)

[Merge Requests](https://gitlab.com/frenware/core/basd/base/-/merge_requests/new) are the best way to propose changes to the codebase. We use GitLab Flow, so all code changes happen through merge requests.

## Report bugs using GitLab's [issues](https://gitlab.com/frenware/core/basd/base/-/issues)

We use GitLab issues to track public bugs. Report a bug by opening a new issue.

### Good Bug Reports include:

- A quick summary and/or background
- Steps to reproduce
  - Be specific
  - Give sample code if you can
- What you expected would happen
- What actually happens

## License

By contributing, you agree that your contributions will be licensed under its [MIT license](https://gitlab.com/frenware/core/basd/base/-/blob/master/LICENSE).
