# @basd/base

> based be thy finger tips

[![npm](https://img.shields.io/npm/v/@basd/base?style=flat&logo=npm)](https://www.npmjs.com/package/@basd/base)
[![pipeline](https://gitlab.com/frenware/core/basd/base/badges/master/pipeline.svg)](https://gitlab.com/frenware/core/basd/base/-/pipelines)
[![license](https://img.shields.io/npm/l/@basd/base)](https://gitlab.com/frenware/core/basd/base/-/blob/master/LICENSE)
[![downloads](https://img.shields.io/npm/dw/@basd/base)](https://www.npmjs.com/package/@basd/base) 

[![Gitlab](https://img.shields.io/badge/Gitlab%20-%20?logo=gitlab&color=%23383a40)](https://gitlab.com/frenware/core/basd/base)
[![Twitter](https://img.shields.io/badge/@basdwon%20-%20?logo=twitter&color=%23383a40)](https://twitter.com/basdwon)
[![Discord](https://img.shields.io/badge/Basedwon%20-%20?logo=discord&color=%23383a40)](https://discordapp.com/users/basedwon)

The core of the [basd](https://gitlab.com/basedwon/basd) library, `@basd/base` extends lodash with various custom utility methods, providing the foundation for building more complex applications. This module is packed with methods for data conversion, environment checks, string manipulation, utility functions, encoding, execution, and more.

## Installation

```bash
npm install @basd/base
```

## Usage

Import `basd` into your project and use it like lodash:

```js
const _ = require('@basd/base')
// or
const { _, log, ...etc } = require('@basd/base')
```

Then, use any of the plethora of methods:

```js
_.log('Hello, World!')
```

## Modules

There are a plethora of modules that are not imported into the main basd instance, but instead can be imported/required directly:

```js
const Evented = require('@basd/base/evented')
const events = new Evented()
events.on('data', (data) => _.log(`got data:`, data))
events.emit('data', `Hello, World!`)
```

## Documentation

- [API Reference](/docs/api.md)

## Tests

In order to run the test suite, simply clone the repository and install its dependencies:

```bash
git clone https://gitlab.com/frenware/core/basd/base.git
cd basd
npm install
```

To run the tests:

```bash
npm test
```

## Contributing

Thank you! Please see our [contributing guidelines](/docs/contributing.md) for details.

## Donations

If you find this project useful and want to help support further development, please send us some coin. We greatly appreciate any and all contributions. Thank you!

**Bitcoin (BTC):**
```
1JUb1yNFH6wjGekRUW6Dfgyg4J4h6wKKdF
```

**Monero (XMR):**
```
46uV2fMZT3EWkBrGUgszJCcbqFqEvqrB4bZBJwsbx7yA8e2WBakXzJSUK8aqT4GoqERzbg4oKT2SiPeCgjzVH6VpSQ5y7KQ
```

## License

basd is [MIT licensed](https://gitlab.com/frenware/core/basd/base/-/blob/master/LICENSE).

